package com.bonus.material.back.controller;

import java.util.List;
import javax.servlet.http.HttpServletResponse;
import com.bonus.common.log.enums.OperaType;
import com.bonus.material.common.annotation.PreventRepeatSubmit;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.bonus.common.log.annotation.SysLog;
import com.bonus.common.security.annotation.RequiresPermissions;
import com.bonus.material.back.domain.BackCheckDetails;
import com.bonus.material.back.service.IBackCheckDetailsService;
import com.bonus.common.core.web.controller.BaseController;
import com.bonus.common.core.web.domain.AjaxResult;
import com.bonus.common.core.utils.poi.ExcelUtil;
import com.bonus.common.core.web.page.TableDataInfo;

/**
 * 退料核查Controller
 * 
 * @author xsheng
 * @date 2024-10-16
 */
@Api(tags = "退料核查接口")
@RestController
@RequestMapping("/back_check_details")
public class BackCheckDetailsController extends BaseController {
    @Autowired
    private IBackCheckDetailsService backCheckDetailsService;

    /**
     * 查询退料核查列表
     */
    @ApiOperation(value = "查询退料核查列表")
    @RequiresPermissions("back:details:list")
    @GetMapping("/list")
    public TableDataInfo list(BackCheckDetails backCheckDetails) {
        startPage();
        List<BackCheckDetails> list = backCheckDetailsService.selectBackCheckDetailsList(backCheckDetails);
        return getDataTable(list);
    }

    /**
     * 导出退料核查列表
     */
    @ApiOperation(value = "导出退料核查列表")
    @PreventRepeatSubmit
    @RequiresPermissions("back:details:export")
    @SysLog(title = "退料核查", businessType = OperaType.EXPORT, logType = 1,module = "仓储管理->导出退料核查")
    @PostMapping("/export")
    public void export(HttpServletResponse response, BackCheckDetails backCheckDetails) {
        List<BackCheckDetails> list = backCheckDetailsService.selectBackCheckDetailsList(backCheckDetails);
        ExcelUtil<BackCheckDetails> util = new ExcelUtil<BackCheckDetails>(BackCheckDetails.class);
        util.exportExcel(response, list, "退料核查数据");
    }

    /**
     * 获取退料核查详细信息
     */
    @ApiOperation(value = "获取退料核查详细信息")
    @RequiresPermissions("back:details:query")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id) {
        return success(backCheckDetailsService.selectBackCheckDetailsById(id));
    }

    /**
     * 新增退料核查
     */
    @ApiOperation(value = "新增退料核查")
    @PreventRepeatSubmit
    @RequiresPermissions("back:details:add")
    @SysLog(title = "退料核查", businessType = OperaType.INSERT, logType = 1,module = "仓储管理->新增退料核查")
    @PostMapping
    public AjaxResult add(@RequestBody BackCheckDetails backCheckDetails) {
        try {
            return toAjax(backCheckDetailsService.insertBackCheckDetails(backCheckDetails));
        } catch (Exception e) {
            return error("系统错误, " + e.getMessage());
        }
    }

    /**
     * 修改退料核查
     */
    @ApiOperation(value = "修改退料核查")
    @PreventRepeatSubmit
    @RequiresPermissions("back:details:edit")
    @SysLog(title = "退料核查", businessType = OperaType.UPDATE, logType = 1,module = "仓储管理->修改退料核查")
    @PutMapping
    public AjaxResult edit(@RequestBody BackCheckDetails backCheckDetails) {
        try {
            return toAjax(backCheckDetailsService.updateBackCheckDetails(backCheckDetails));
        } catch (Exception e) {
            return error("系统错误, " + e.getMessage());
        }
    }

    /**
     * 删除退料核查
     */
    @ApiOperation(value = "删除退料核查")
    @PreventRepeatSubmit
    @RequiresPermissions("back:details:remove")
    @SysLog(title = "退料核查", businessType = OperaType.DELETE, logType = 1,module = "仓储管理->删除退料核查")
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids) {
        return toAjax(backCheckDetailsService.deleteBackCheckDetailsByIds(ids));
    }
}
